package hideandseek.disguise;

import hideandseek.xseries.XMaterial;
import org.bukkit.Material;
import me.libraryaddict.disguise.disguisetypes.MobDisguise;
import me.libraryaddict.disguise.disguisetypes.DisguiseType;
import me.libraryaddict.disguise.disguisetypes.Disguise;
import org.bukkit.entity.Entity;
import me.libraryaddict.disguise.DisguiseAPI;
import org.bukkit.inventory.ItemStack;
import org.bukkit.entity.Player;
import me.libraryaddict.disguise.disguisetypes.MiscDisguise;
import java.lang.reflect.Constructor;

public class LibsDisguises extends DisguiseManager
{
    Constructor<MiscDisguise> newConstructor;
    
    @Override
    public void disguise(final Player var1, final ItemStack var2) {
        final MiscDisguise var3 = this.getDisguise(var2);
        DisguiseAPI.disguiseToAll((Entity)var1, (Disguise)var3);
    }
    
    @Override
    public void disguise(final Player var1, final String var2) {
        final MobDisguise var3 = new MobDisguise(DisguiseType.valueOf(var2));
        DisguiseAPI.disguiseToAll((Entity)var1, (Disguise)var3);
    }
    
    @Override
    public void undisguise(final Player var1) {
        DisguiseAPI.undisguiseToAll((Entity)var1);
    }
    
    @Override
    public boolean valid() {
        try {
            this.newConstructor = MiscDisguise.class.getConstructor(DisguiseType.class, Material.class, Integer.TYPE);
        }
        catch (final Exception ex) {}
        try {
            this.getDisguise(XMaterial.GRASS_BLOCK.parseItem());
            return true;
        }
        catch (final Exception var2) {
            var2.printStackTrace();
            return false;
        }
    }
    
    @Override
    public String getName() {
        return "Libs Disguise";
    }
    
    private MiscDisguise getDisguise(final ItemStack var1) {
        return (this.newConstructor != null) ? new MiscDisguise(DisguiseType.FALLING_BLOCK, var1) : new MiscDisguise(DisguiseType.FALLING_BLOCK, var1.getType().getId(), (int)var1.getDurability());
    }
}
